"use strict";Object.defineProperty(exports,"__esModule",{value:true});const logger_1=require("./logger");const os=require("os");const url=require("url");const https=require("https");const ports_1=require("./ports");const PING_URL="https://datacollector.dripstat.com/agent/v1/ping";const INIT_URL="https://datacollector.dripstat.com/agent/v1/v1/nodejs/init";const SEND_DATA_URL="https://datacollector.dripstat.com/agent/v1/v1/nodejs/data";const TIMEOUT_MS=7e3;const RETRY_MS=7e3;var ResponseType;(function(ResponseType){ResponseType[ResponseType["OK"]=0]="OK";ResponseType[ResponseType["AUTH_TOKEN_EXPIRED"]=1]="AUTH_TOKEN_EXPIRED";ResponseType[ResponseType["ERROR"]=2]="ERROR"})(ResponseType=exports.ResponseType||(exports.ResponseType={}));class AppMetrics{}class AppMetricData{constructor(){this.metrics=[];this.traces=[];this.errs=[];this.sql=[]}}class AppMetricsNamedId{constructor(){this.named={};this.id={}}}class AppMetricsTransactions{constructor(){this.noParent={};this.parent=new AppMetricsNamedId;this.async=new AppMetricsNamedId}}class SendDataRequest{constructor(){this.cmdAcks=[];this.metrics=[]}}class SendDataResponseAppListData{constructor(){this.noparent=[];this.parented=[];this.async=[]}}class SendDataResponseAppList{}class DripstatServer{constructor(config){this.config=config;this.isConnected=false;this.transactionNameMapping={};this.asyncTransactionSegmentNameMapping={}}auditLog(url,options,data,responseBody,resp){if(this.config.auditMode){if(resp||responseBody){logger_1.agentLogger.audit(`Received: url=${url}, headers=${resp?JSON.stringify(resp.headers):""} response=${resp?resp.statusCode:"?"}, response body:\n${responseBody}`)}else{logger_1.agentLogger.audit(`Sent: url=${url}, headers=${options?JSON.stringify(options.headers):""} request:body:\n${JSON.stringify(data)}`)}}}ping(){const that=this;this.request(PING_URL,{},null,(err,res,body)=>{that.isConnected=body=="pinged"})}authenticate(callback){const ports=ports_1.getPorts();const body={host:os.hostname(),port:ports?ports[0]:80,cpuCount:os.cpus().length,systemRam:os.totalmem()};const options={method:"POST",headers:{"X-License-Key":this.config.licenseKey,"X-App-Name":this.config.appName,"Content-Type":"application/json"}};this.request(INIT_URL,options,body,(respType,res,body)=>{if(respType!=ResponseType.OK){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.ERROR))logger_1.agentLogger.error(`Error authenticating with DripStat server ${respType}`);this.appId=null;this.authToken=null;callback(respType);return}if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`code=${res?res.statusCode:"null"} body=${body}.`);const resp=JSON.parse(body);this.appId=resp.appid;this.authToken=resp.authtoken;callback(respType)})}sendMetric(data,callback){if(!this.authToken){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.WARNING))logger_1.agentLogger.warning(`No Authentication Token received from DripStat server yet. Retrying authentication with DripStat server`);return}const body=this.prepareData(data);const options={method:"POST",headers:{"Content-Type":"application/json","X-Auth-Token":this.authToken}};this.request(SEND_DATA_URL,options,body,(respType,res,body)=>{if(respType!=ResponseType.OK){callback(respType);return}const resp=JSON.parse(body);if(resp.appList){for(const app of resp.appList){if(app.data&&app.data.noparent){for(const mapping of app.data.noparent){if(mapping&&mapping.name&&mapping.id){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`Added transaction name mapping ${mapping.name} -> ${mapping.id}`);this.transactionNameMapping[mapping.name]=`${mapping.id}`}}}if(app.data&&app.data.parented){}if(app.data&&app.data.async){for(const mapping of app.data.async){if(mapping&&mapping.parent&&mapping.name&&mapping.id){if(!this.asyncTransactionSegmentNameMapping[mapping.parent])this.asyncTransactionSegmentNameMapping[mapping.parent]={};if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`Added async segment name mapping ${mapping.parent}/${mapping.name} -> ${mapping.id}`);this.asyncTransactionSegmentNameMapping[mapping.parent][mapping.name]=`${mapping.id}`}}}}}})}connected(){return this.isConnected}isAuthenticated(){return!!this.authToken&&!!this.appId}retry(uri,options,body,callback,retryCount){setTimeout(function(){this.request(uri,options,body,callback,retryCount+1)}.bind(this),RETRY_MS)}request(uri,options,body,callback,retryCount=0){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`Request to ${uri} retryCount=${retryCount}`);const retryIfNeeded=retryCount==0;const that=this;this.auditLog(uri,options,body);const u=url.parse(uri);options.host=u.host;options.path=u.path;if(!options.method)options.method="GET";const req=https.request(options,function(res){res.setEncoding("utf8");res.on("data",function(chunk){that.auditLog(uri,options,body,chunk?chunk.toString():null,res);if(res.statusCode==500){if(retryIfNeeded){that.retry(uri,options,body,callback,retryCount+1);return}}else if(res.statusCode==401){callback(ResponseType.AUTH_TOKEN_EXPIRED,null,null)}else if(res.statusCode==200){callback(ResponseType.OK,res,chunk)}else{callback(ResponseType.ERROR,res,"")}if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug("Response: "+chunk)})});req.on("socket",function(socket){socket.setTimeout(TIMEOUT_MS);socket.on("timeout",function(){req.abort()})});req.on("error",function(err){if(err.code==="ECONNRESET"){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.ERROR))logger_1.agentLogger.error(`Timeout occured: ${err}, code=${err&&err.code?err.code:"?"}`)}else{if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.ERROR))logger_1.agentLogger.error(`Request error occured: ${err}`)}if(retryIfNeeded){that.retry(uri,options,body,callback,retryCount+1)}else{callback(ResponseType.ERROR,null,"")}});if(body){req.write(JSON.stringify(body))}req.end()}prepareData(data){const metrics=new AppMetrics;metrics.appName=this.config.appName;metrics.metricData=new AppMetricData;metrics.metricData.txns=new AppMetricsTransactions;if(data.traces){metrics.metricData.traces=[];for(const key in data.traces){const sampler=data.traces[key];if(sampler){const traces=sampler.traces;for(const trace of traces){metrics.metricData.traces.push(trace.toJson())}}}}if(data.errors){metrics.metricData.errs=[];for(const key in data.errors){const error=data.errors[key];metrics.metricData.errs.push(error.toJson())}}const transactionStats=data.transactionStats;const transactionSegmentStats=data.metrics;for(const transName in transactionStats){const stat=transactionStats[transName];const name=this.transactionNameMapping[transName]?this.transactionNameMapping[transName]:transName;metrics.metricData.txns.noParent[name]=stat.toTransactionJson()}for(const transName in transactionSegmentStats){const stats=transactionSegmentStats[transName];if(stats){metrics.metricData.txns.async.named[transName]={};for(let metricName in stats){const stat=stats[metricName];metricName="Async/"+metricName;if(this.asyncTransactionSegmentNameMapping[transName]&&this.asyncTransactionSegmentNameMapping[transName][metricName]){metrics.metricData.txns.async.id[this.asyncTransactionSegmentNameMapping[transName][metricName]]=stat.toSegmentJson()}else{metrics.metricData.txns.async.named[transName][metricName]=stat.toSegmentJson()}}}}const body=new SendDataRequest;body.appMetrics=[metrics];return body}}exports.DripstatServer=DripstatServer;