"use strict";Object.defineProperty(exports,"__esModule",{value:true});const utils_1=require("./utils");const TXNTRACE_VERSION=4;const MAX_DEPTH=70;const TRACE_LINE_ONLY_FILE=/^\s*at\s+(.*:\d+:\d+)\s*$/;const TRACE_LINE_FUNCTION_AND_FILE=/^\s*at\s+(.*)\s+\((.*:\d+:\d+)\)\s*$/;const UNKNOWN_EXCEPTION_CLASS="Unknown";class ExceptionParser{static parse(exc){const data=new StackTraceData;if(!exc)return data;const lines=exc.split("\n");for(let n=0;n<lines.length;n++){let line=lines[n];if(n==0){data.message=line.replace(/^Error:?\s*/,"")}else if(n==1){let arr;if(arr=TRACE_LINE_ONLY_FILE.exec(line)){if(arr.length>=1)data.exceptionCls=arr[1];else data.exceptionCls=UNKNOWN_EXCEPTION_CLASS}else if(arr=TRACE_LINE_FUNCTION_AND_FILE.exec(line)){if(arr.length>=1){const caller=arr[1];if(caller.match(/[\w\d]+\..*/)){data.exceptionCls=caller.split(".")[0]}else{data.exceptionCls=caller}}else data.exceptionCls=UNKNOWN_EXCEPTION_CLASS}else{data.exceptionCls=UNKNOWN_EXCEPTION_CLASS}}lines[n]=lines[n].trim().replace(/^at\s+/,"")}lines.shift();data.stackTrace=ExceptionParser.truncateStack(lines);return data}static truncateStack(lines){if(!lines||lines.length<=MAX_DEPTH){return lines}const bottomLimit=Math.floor(MAX_DEPTH/3);const topLimit=MAX_DEPTH-bottomLimit;const skipCount=lines.length-bottomLimit-topLimit;const topStack=lines.slice(0,topLimit);const bottomStack=lines.slice(lines.length-bottomLimit,lines.length);const truncated=[];truncated.push(...topStack);truncated.push(`Skipped ${skipCount} lines..`);truncated.push(...bottomStack);return truncated}}exports.ExceptionParser=ExceptionParser;class StackTraceData{}exports.StackTraceData=StackTraceData;class ExceptionData{constructor(parsed,transName,customParams){this.message=parsed.message?parsed.message:"";this.exceptionCls=parsed.exceptionCls;this.stackTrace=parsed.stackTrace;this.count=1;this.txName=transName;this.params=customParams?customParams:{}}toJson(){const j={ms:this.message,cl:this.exceptionCls,ct:this.count,tx:this.txName,stack:this.stackTrace};if(this.params)j["cPrms"]=this.params;return j}}exports.ExceptionData=ExceptionData;class TTElement{constructor(timeMillis,stacktrace){this.timeMillis=timeMillis;this.stacktrace=stacktrace;this.children=[]}toJson(){const children=[];if(this.children){for(const child of this.children){children.push(child.toJson())}}return[utils_1.millisToNanos(this.timeMillis),null,`${this.stacktrace.exceptionCls}::()V`,null,this.stacktrace.stackTrace,null,children]}}exports.TTElement=TTElement;class TraceData{constructor(transaction,exceptionData){this.stacktrace=exceptionData;this.started=transaction.started;this.rootStacktrace=transaction.rootStacktrace;this._transactionName=transaction.getName();this._transactionTime=transaction.timer.time;this.timers=transaction.timers;if(transaction.statusCode){this.statusCode=transaction.statusCode}if(transaction.queryParams){this.queryParams=transaction.queryParams}this.config=transaction.config}get transactionName(){return this._transactionName}get transactionTime(){return this._transactionTime}toJson(){const ttElement=new TTElement(this._transactionTime,this.stacktrace);const asyncStats={};if(this.timers){for(const metricName in this.timers){let minTime,maxTime,totalTime=0;const timers=this.timers[metricName];for(const timer of timers){if(!minTime||timer.time<minTime)minTime=timer.time;if(!maxTime||timer.time>maxTime)maxTime=timer.time;totalTime+=timer.time}const timer=this.timers[metricName];asyncStats[metricName]=[1,minTime,maxTime,totalTime]}}return[TXNTRACE_VERSION,this._transactionName,utils_1.millisToNanos(this._transactionTime),false,ttElement.toJson(),this.started,asyncStats,null,this.stacktrace.toJson(),this.statusCode,this.queryParams]}}exports.TraceData=TraceData;