"use strict";Object.defineProperty(exports,"__esModule",{value:true});const url=require("url");const metrics_1=require("./metrics");const logger_1=require("./logger");const DEFAULT_TRANSACTION_NAME="/<unnamedTxn>";class Transaction{constructor(asyncId,config){this.asyncId=asyncId;this.config=config;this._finished=false;this._isError=false;this._timers={};const timer=new metrics_1.Timer("transaction",metrics_1.TimerType.Async);this._timer=timer;this.started=Date.now()}get timer(){return this._timer}get isError(){return this._isError}set isError(isError){this._isError=isError}get finished(){return this._finished}set finished(finished){this._finished=finished}get timers(){return this._timers}get stacktrace(){return this._stacktrace}get stacktraceParams(){return this._stacktraceParams}get rootStacktrace(){return this._rootStacktrace}recordRootStacktrace(err){if(!err)return;this._rootStacktrace=err.stack}recordError(err,params){if(!err)return;this._stacktrace=err.stack;this._stacktraceParams=params}getName(){if(this.name)return this.name;return DEFAULT_TRANSACTION_NAME}setName(name){if(!name){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.WARNING))logger_1.agentLogger.warning("Empty transaction name");name="/__empty_name__"}if(!name.match(/^\/.*/)){name="/"+name}this.name=name}startTimer(metricName,type){return new metrics_1.Timer(metricName,type)}finishTimer(timer){if(!timer){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.WARNING))logger_1.agentLogger.warning("Cannot stop an unstarted timer %s",timer.metricName);return null}if(this.finished){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`Transaction already finished, ignoring timer ${timer.metricName}`);return null}timer.stop();if(timer.time>=this.config.stackThreshold){timer.stacktrace=(new Error).stack}if(!this.timers[timer.metricName])this.timers[timer.metricName]=[];this.timers[timer.metricName].push(timer);return timer}}exports.Transaction=Transaction;class WebTransaction extends Transaction{constructor(asyncId,config){super(asyncId,config)}get queryParams(){return this._queryParams}initialize(req){this.url=req.url;this.method=req.method;this.remoteAddr=req.socket?req.socket.remoteAddress:"???";this.headers=req.headers;if(this.config.captureRequestParams){const q=url.parse(req.url,true).query;if(q){this._queryParams={};for(const key in q){this._queryParams[key]=`${q[key]}`}}}}}exports.WebTransaction=WebTransaction;class ApplicationTransaction extends Transaction{constructor(asyncId,config){super(asyncId,config)}}exports.ApplicationTransaction=ApplicationTransaction;